#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=png\Chat.ico
#AutoIt3Wrapper_outfile=CryptChat_Client.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Comment=Datum: 18.01.2010
#AutoIt3Wrapper_Res_Description=CryptChat-Client
#AutoIt3Wrapper_Res_Fileversion=0.9.7.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <EditConstants.au3>
#include <GuiStatusBar.au3>
#include <Date.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Inet.au3>
#include "Chatbox.au3"
Global $iCC_ServerPort = 64064
Global $sTitle = 'CryptChat-Client v0.9.7'
Global $iCC_ClientSocket = '', $hGui

TCPStartup()
If @error Then _Close('FEHLER!' & @CRLF & 'TCP-Service konnte nicht gestartet werden!')
Global $sIP = _GetIP()
If $sIP = -1 Then _Close('FEHLER!' & @CRLF & 'Internetverbindung konnte nicht hergestellt werden!')

Global $sIniFile = @ScriptDir & '\CryptChat_Client.ini'
Global $sCC_ServerIP = IniRead($sIniFile, 'Connection', 'ServerIP', '')
Global $sUserName = StringRegExpReplace(IniRead($sIniFile, 'Connection', 'UserName', @UserName), '\W', '')
Global $sPassword = IniRead($sIniFile, 'Connection', 'Password', 'asdf')

$hGui = GUICreate($sTitle, 600, 600, -1, -1, BitOR($GUI_SS_DEFAULT_GUI, $WS_SIZEBOX))
GUISetIcon(@ScriptDir & '\png\chat.ico')
GUISetBkColor(0xddaa77)
$hChat = _Chatbox_Create($hGui, 10, 10, 580, 420, 0xffffaa, @ScriptDir & '\Chatlog_Client.html')
GUICtrlCreateLabel('Server-IP oder -URL (z.B. DynDNS-Adresse)', 12, 460, 240, 20)
GUICtrlSetFont(-1, 9)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hServerIP = GUICtrlCreateInput($sCC_ServerIP, 10, 480, 260, 20, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_WANTRETURN))
GUICtrlSetResizing(-1, 64 + 512)
GUICtrlCreateLabel('Mein Benutzername', 292, 460, 230, 20)
GUICtrlSetFont(-1, 9)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hUserName = GUICtrlCreateInput($sUserName, 290, 480, 240, 20, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_WANTRETURN))
GUICtrlSetResizing(-1, 64 + 512)
$hConnect = GUICtrlCreateButton('Verbinden', 535, 480, 60, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hSmiley = GUICtrlCreateButton('Smiley auswhlen', 10, 522, 110, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hUserList = GUICtrlCreateButton('Wer ist online?', 140, 522, 110, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hHelp = GUICtrlCreateButton('Hilfe', 270, 522, 80, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hLockIco = GUICtrlCreateIcon(@ScriptDir & '\png\conn0.ico', -1, 552, 442, 32, 32)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hUser = GUICtrlCreateInput('', 10, 550, 520, 20, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_WANTRETURN))
GUICtrlSetResizing(-1, 64 + 512)
$hEnter = GUICtrlCreateButton('Senden', 535, 550, 60, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hStatus = _GUICtrlStatusBar_Create($hGui)
GUISetState()
GUIRegisterMsg($WM_SIZE, '_WM_SIZE')
GUIRegisterMsg($WM_GETMINMAXINFO, '_WM_GETMINMAXINFO')
WinSetOnTop($hGui, '', 1)
GUICtrlSetState($hUser, $GUI_FOCUS)
GUICtrlSetState($hEnter, $GUI_DEFBUTTON)
GUICtrlSetState($hUser, $GUI_DISABLE)
GUICtrlSetState($hEnter, $GUI_DISABLE)
GUICtrlSetState($hSmiley, $GUI_DISABLE)
GUICtrlSetState($hUserList, $GUI_DISABLE)
GUICtrlSetState($hHelp, $GUI_DISABLE)
While True
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE
			_Close()
		Case $hConnect
			If GUICtrlRead($hConnect) = 'Verbinden' Then
				$tmp = GUICtrlRead($hServerIP)
				$sCC_ServerIP = $tmp
				_ConnectServer()
				If Not @error Then IniWrite($sIniFile, 'Connection', 'ServerIP', $tmp)
			Else
				TCPCloseSocket($iCC_ClientSocket)
				$iCC_ClientSocket = ''
				_Chatbox_SetData($hChat, '[b]' & _Now() & '[/b] >>> Verbindung getrennt!', 0x000000, 2)
				_GUICtrlStatusBar_SetText($hStatus, 'Keine Verbindung zum Server!')
				GUICtrlSetData($hConnect, 'Verbinden')
				GUICtrlSetImage($hLockIco, @ScriptDir & '\png\conn0.ico')
				_ButtonsSwitch(False)
			EndIf
		Case $hUserName
			$sUserName = GUICtrlRead($hUserName)
			IniWrite($sIniFile, 'Connection', 'UserName', $sUserName)
		Case $hSmiley
			_Chatbox_SmileyToText($hUser, '', -1, -1, $hGui)
			GUICtrlSetState($hUser, $GUI_FOCUS)
			GUICtrlSetState($hEnter, $GUI_DEFBUTTON)
		Case $hUserList
			TCPSend($iCC_ClientSocket, _StringEncryptXOR('/UL', $sPassword))
		Case $hHelp
			_HelpMsg()
		Case $hEnter
			$tmp = GUICtrlRead($hUser)
			Select
				Case $tmp = '/HELP' Or $tmp = '/?' Or $tmp = '/HILFE'
					_HelpMsg()
				Case StringLeft($tmp, 2) = '/sf'

				Case Else
					TCPSend($iCC_ClientSocket, _StringEncryptXOR($tmp, $sPassword))
					_Chatbox_SetData($hChat, '[color=#dd0000][b]' & _Now() & ' Ich:[/b][/color] ' & $tmp, 0x000000, 3)
			EndSelect
			If StringLeft($tmp, 2) = '/w' Then
				GUICtrlSetData($hUser, StringRegExpReplace($tmp, '(\/w \w+ ).+', '$1'))
			Else
				GUICtrlSetData($hUser, '')
			EndIf
			GUICtrlSetState($hUser, $GUI_FOCUS)
			GUICtrlSetState($hEnter, $GUI_DEFBUTTON)
	EndSwitch
	If GUICtrlRead($hUserName) <> $sUserName Then
		$sUserName = StringRegExpReplace(GUICtrlRead($hUserName), '\W', '')
		GUICtrlSetData($hUserName, $sUserName)
		IniWrite($sIniFile, 'Connection', 'UserName', $sUserName)
	EndIf
	If $iCC_ClientSocket <> '' Then
		$tmp = TCPRecv($iCC_ClientSocket, 1024, 1)
		If @error Then
			_Chatbox_SetData($hChat, '[b]' & _Now() & '[/b] >>> Verbindung zum Server unterbrochen!', 0x000000, 2)
			_GUICtrlStatusBar_SetText($hStatus, 'Verbindung zum Server unterbrochen!')
			GUICtrlSetImage($hLockIco, @ScriptDir & '\png\conn0.ico')
			GUICtrlSetData($hConnect, 'Verbinden')
			Switch MsgBox(262144 + 32 + 4, $sTitle, 'FEHLER!' & @CRLF & 'Verbindung zum Server unterbrochen!' & @CRLF & 'Neu verbinden?', 0, $hGui)
				Case 6
					_ConnectServer()
				Case Else
					_Close()
			EndSwitch
		EndIf
		$tmp = _StringEncryptXOR(BinaryToString($tmp), $sPassword)
		If $tmp <> '' Then _Chatbox_SetData($hChat, $tmp, 0x000000, 3)
	EndIf
WEnd

Func _HelpMsg()
	Local $msg
	$msg = '[b][size=4]Hilfe[/size][/b][hr]'
	$msg &= '[b][color=#000000][u]Befehlsliste:[/u][/color][/b]' & @CRLF
	$msg &= '[b][color=#0000ff]/ul[/color][/b] = Benutzerliste (wer ist online?)' & @CRLF
;~ 	$msg &= '[b][color=#0000ff]/sf Benutzer Dateiname[/color][/b] = Sende Datei an diesen Benutzer' & @CRLF
	$msg &= '[b][color=#0000ff]/w Benutzer Nachricht[/color][/b] = Nachricht nur an diesen Benutzer schicken' & @CRLF & @CRLF
	$msg &= '[b][color=#000000][u]BB-Codes (ohne die Leerzeichen eingeben):[/u][/color][/b]' & @CRLF
	$msg &= '[b][color=#0000ff][ b ][/color][/b]Fettschrift[b][color=#0000ff][ /b ][/color][/b] = [b]Fettschrift[/b]' & @CRLF
	$msg &= '[b][color=#0000ff][ i ][/color][/b]Kursivschrift[b][color=#0000ff][ /i ][/color][/b] = [i]Kursivschrift[/i]' & @CRLF
	$msg &= '[b][color=#0000ff][ u ][/color][/b]unterstrichen[b][color=#0000ff][ /u ][/color][/b] = [u]unterstrichen[/u]' & @CRLF
	$msg &= '[b][color=#0000ff][ color=#009900 ][/color][/b]grner Text[b][color=#0000ff][ /color ][/color][/b] = [color=#009900]grner Text[/color]' & @CRLF
	$msg &= '[b][color=#0000ff][ size=5 ][/color][/b]groer Text[b][color=#0000ff][ /size ][/color][/b] = [size=5]groer Text[/size]' & @CRLF
	$msg &= '[hr]' & @CRLF
	_Chatbox_SetData($hChat, $msg, 0x000000, 2)
EndFunc

Func _WM_SIZE($hWnd, $iMsg, $iwParam, $ilParam)
	_GUICtrlStatusBar_Resize($hStatus)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_SIZE

Func _WM_GETMINMAXINFO($hWnd, $msg, $wParam, $lParam)
	Local $minmaxinfo
	If $hWnd = $hGui Then
		$minmaxinfo = DllStructCreate('int;int;int;int;int;int;int;int;int;int', $lParam)
		DllStructSetData($minmaxinfo, 7, 612)
		DllStructSetData($minmaxinfo, 8, 612)
	EndIf
EndFunc   ;==>_WM_GETMINMAXINFO

Func _ButtonsSwitch($bSwitch)
	Switch $bSwitch
		Case True
			GUICtrlSetState($hUser, $GUI_ENABLE)
			GUICtrlSetState($hHelp, $GUI_ENABLE)
			GUICtrlSetState($hEnter, $GUI_ENABLE)
			GUICtrlSetState($hSmiley, $GUI_ENABLE)
			GUICtrlSetState($hUserList, $GUI_ENABLE)
		Case False
			GUICtrlSetState($hUser, $GUI_DISABLE)
			GUICtrlSetState($hHelp, $GUI_DISABLE)
			GUICtrlSetState($hEnter, $GUI_DISABLE)
			GUICtrlSetState($hSmiley, $GUI_DISABLE)
			GUICtrlSetState($hUserList, $GUI_DISABLE)
	EndSwitch
EndFunc

Func _ConnectServer()
	If $sUserName = '' Then
		_GUICtrlStatusBar_SetText($hStatus, 'FEHLER! Kein Benutzername eingetragen!')
		Return SetError(1, 0, 0)
	EndIf
	Local $iTimer, $tmp
	_GUICtrlStatusBar_SetText($hStatus, 'Verbinde mit Server: ' & $sCC_ServerIP & '    Bitte warten...')
	If Not StringRegExp($sCC_ServerIP, '\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}') Then $sCC_ServerIP = TCPNameToIP($sCC_ServerIP)
	$iCC_ClientSocket = TCPConnect($sCC_ServerIP, $iCC_ServerPort)
	If @error Then
		$iCC_ClientSocket = ''
		GUICtrlSetState($hServerIP, $GUI_FOCUS)
		_GUICtrlStatusBar_SetText($hStatus, 'Verbindung konnte nicht hergestellt werden! Server nicht erreichbar!')
		GUICtrlSetData($hConnect, 'Verbinden')
		Return SetError(1, 0, 0)
	EndIf
	_GUICtrlStatusBar_SetText($hStatus, 'Verbindung hergestellt! Authentifizierung beginnt...')
	GUISetState($hGui, @SW_DISABLE)
	$iTimer = TimerInit()
	TCPSend($iCC_ClientSocket, $sUserName)
	Do
		$tmp = TCPRecv($iCC_ClientSocket, 1024)
		Switch StringLeft($tmp, 5)
			Case 'PASSW'
				$sPassword = IniRead($sIniFile, 'Connection', 'Password', 'asdf')
				$sPassword = InputBox($sTitle, 'Bitte das Passwort eingeben!', $sPassword, '', 200, 130, Default, Default, 30, $hGui)
				If Not @error Then TCPSend($iCC_ClientSocket, _StringEncryptXOR($sUserName & '|' & $sPassword, $sPassword))
			Case 'CONN1'
				_Chatbox_SetData($hChat, '[b]' & _Now() & '[/b] >>> Du bist angemeldet!', 0x000000, 2)
				_GUICtrlStatusBar_SetText($hStatus, 'Bereit zum chatten!')
				IniWrite($sIniFile, 'Connection', 'Password', $sPassword)
				GUICtrlSetState($hUser, $GUI_FOCUS)
				GUICtrlSetData($hConnect, 'Trennen')
				GUICtrlSetImage($hLockIco, @ScriptDir & '\png\conn1.ico')
				_ButtonsSwitch(True)
				GUISetState($hGui, @SW_ENABLE)
				Return SetError(0, 0, 1)
			Case 'CONN0'
				TCPCloseSocket($iCC_ClientSocket)
				$iCC_ClientSocket = ''
				_Chatbox_SetData($hChat, '[b]' & _Now() & '[/b] >>> Falsches Passwort!', 0x000000, 2)
				_GUICtrlStatusBar_SetText($hStatus, 'Falsches Passwort! Verbindung zum Server getrennt!')
				GUICtrlSetImage($hLockIco, @ScriptDir & '\png\conn0.ico')
				GUICtrlSetData($hConnect, 'Verbinden')
				_ButtonsSwitch(False)
				GUISetState($hGui, @SW_ENABLE)
				Return SetError(1, 0, 0)
			Case 'EXIST'
				TCPCloseSocket($iCC_ClientSocket)
				$iCC_ClientSocket = ''
				_Chatbox_SetData($hChat, '[b]' & _Now() & '[/b] >>> Benutzername existiert bereits!', 0x000000, 2)
				_GUICtrlStatusBar_SetText($hStatus, 'Benutzername existiert bereits! Verbindung zum Server getrennt!')
				GUICtrlSetImage($hLockIco, @ScriptDir & '\png\conn0.ico')
				GUICtrlSetData($hConnect, 'Verbinden')
				_ButtonsSwitch(False)
				GUISetState($hGui, @SW_ENABLE)
				Return SetError(1, 0, 0)
		EndSwitch
	Until TimerDiff($iTimer) > 30000
	TCPCloseSocket($iCC_ClientSocket)
	$iCC_ClientSocket = ''
	_Chatbox_SetData($hChat, '[b]' & _Now() & '[/b] >>> Zeitberschreitung!', 0x000000, 2)
	_GUICtrlStatusBar_SetText($hStatus, 'Zeitberschreitung! Verbindung zum Server getrennt!')
	GUICtrlSetData($hConnect, 'Verbinden')
	GUICtrlSetImage($hLockIco, @ScriptDir & '\png\conn0.ico')
	_ButtonsSwitch(False)
	GUISetState($hGui, @SW_ENABLE)
	Return SetError(1, 0, 0)
EndFunc   ;==>_ConnectServer

Func _StringEncryptXOR($sText, $sPass)
	Local $sOut, $iTextChar, $iPos, $iPassChar, $iLen = StringLen($sPass)
	For $i = 1 To StringLen($sText)
		$iTextChar = Asc(StringMid($sText, $i, 1))
		$iPos = Mod($i, $iLen)
		$iPassChar = Asc(StringMid($sPass, $iPos, 1))
		$sOut &= Chr(BitXOR($iTextChar, $iPassChar))
	Next
	Return $sOut
EndFunc   ;==>_StringEncryptXOR

Func _Close($sErrMsg = '')
	If $sErrMsg <> '' Then MsgBox(262144 + 16, $sTitle, $sErrMsg, 0, $hGui)
	TCPCloseSocket($iCC_ClientSocket)
	TCPShutdown()
	Exit
EndFunc   ;==>_Close
