#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=png\Chat.ico
#AutoIt3Wrapper_outfile=CryptChat_Server.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Comment=Datum: 18.01.2010
#AutoIt3Wrapper_Res_Description=CryptChat-Server
#AutoIt3Wrapper_Res_Fileversion=0.9.7.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Inet.au3>
#include <EditConstants.au3>
#include <GuiStatusBar.au3>
#include <Date.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include <Misc.au3>
#include "Chatbox.au3"

Global $iCC_ServerPort = 64064
Global $sTitle = 'CryptChat-Server v0.9.7'
If _Singleton($sTitle, 1) = 0 Then Exit MsgBox(48, $sTitle, 'Das Serverprogramm luft bereits!')

Global $iCC_ServerSocket, $sCC_ServerIP, $aCC_ConnectSocket[1], $aCC_ConnectUser[1] = ['Admin'], $aCC_ConnectIP[1]
TCPStartup()
If @error Then _Close('FEHLER!' & @CRLF & 'TCP-Service konnte nicht gestartet werden!')
$sCC_ServerIP = TCPNameToIP(@ComputerName)
If @error Then _Close('FEHLER!' & @CRLF & 'Konnte eigene IP-Adresse nicht ermitteln!')
$iCC_ServerSocket = TCPListen($sCC_ServerIP, $iCC_ServerPort)
If @error Then _Close('FEHLER!' & @CRLF & 'TCP-Socket konnte nicht erstellt werden!')

Global $sIniFile = @ScriptDir & '\CryptChat_Server.ini'
Global $sAdminName = StringRegExpReplace(IniRead($sIniFile, 'Connection', 'UserName', 'Admin'), '\W', '')
Global $sPassword = IniRead($sIniFile, 'Connection', 'Password', 'asdf')

$hGui = GUICreate($sTitle, 600, 600, -1, -1, BitOR($GUI_SS_DEFAULT_GUI, $WS_SIZEBOX))
GUISetIcon(@ScriptDir & '\png\chat.ico')
GUISetBkColor(0x4488bb)
$hChat = _Chatbox_Create($hGui, 10, 10, 580, 400, 0xffffaa, @ScriptDir & '\Chatlog_Server.html')
GUICtrlCreateLabel('WAN-Server-IP (an Benutzer bermitteln)', 12, 422, 280, 16)
GUICtrlSetFont(-1, 9)
GUICtrlSetResizing(-1, 64 + 256 + 512)
GUICtrlCreateInput(_GetIP(), 10, 440, 260, 20, $ES_READONLY)
GUICtrlSetResizing(-1, 64 + 512)
GUICtrlCreateLabel('Chat-Passwort (an Benutzer bermitteln)', 292, 422, 230, 16)
GUICtrlSetFont(-1, 9)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hPassword = GUICtrlCreateInput($sPassword, 290, 440, 240, 20, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_WANTRETURN))
GUICtrlSetResizing(-1, 64 + 512)
$hAccept1 = GUICtrlCreateButton('ndern', 535, 440, 60, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
GUICtrlSetTip(-1, 'Achtung! Das ndern des Passworts trennt alle offenen Verbindungen!')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateLabel('LAN-Server-IP (evtl. Router-Portweiterleitung)', 12, 472, 280, 16)
GUICtrlSetFont(-1, 9)
GUICtrlSetResizing(-1, 64 + 256 + 512)
GUICtrlCreateInput($sCC_ServerIP & '     (TCP-Port: ' & $iCC_ServerPort & ')', 10, 490, 260, 20, $ES_READONLY)
GUICtrlSetResizing(-1, 64 + 512)
GUICtrlCreateLabel('Mein Benutzername', 292, 472, 230, 16)
GUICtrlSetFont(-1, 9)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hAdminName = GUICtrlCreateInput($sAdminName, 290, 490, 240, 20, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_WANTRETURN))
GUICtrlSetResizing(-1, 64 + 512)
$hSmiley = GUICtrlCreateButton('Smiley auswhlen', 10, 522, 110, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hUserList = GUICtrlCreateButton('Wer ist online?', 140, 522, 110, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hHelp = GUICtrlCreateButton('Hilfe', 270, 522, 80, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hUser = GUICtrlCreateInput('', 10, 550, 520, 20, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_WANTRETURN))
GUICtrlSetResizing(-1, 64 + 512)
$hEnter = GUICtrlCreateButton('Senden', 535, 550, 60, 20)
GUICtrlSetResizing(-1, 64 + 256 + 512)
$hStatus = _GUICtrlStatusBar_Create($hGui)
_GUICtrlStatusBar_SetText($hStatus, 'Angemeldete Benutzer: ' & UBound($aCC_ConnectSocket))
GUISetState()

GUIRegisterMsg($WM_SIZE, '_WM_SIZE')
GUIRegisterMsg($WM_GETMINMAXINFO, '_WM_GETMINMAXINFO')
WinSetOnTop($hGui, '', 1)
AdlibRegister('_CC_Connect', 1000)
GUICtrlSetState($hUser, $GUI_FOCUS)
GUICtrlSetState($hEnter, $GUI_DEFBUTTON)
While True
	_CC_ReceiveMsg()
WEnd

Func _CC_ReceiveMsg()
	Local $tmp, $msg, $sWUser, $sMsg
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE
			_Close()
		Case $hSmiley
			_Chatbox_SmileyToText($hUser, '', -1, -1, $hGui)
			GUICtrlSetState($hUser, $GUI_FOCUS)
		Case $hAdminName
			$sAdminName = GUICtrlRead($hAdminName)
			IniWrite($sIniFile, 'Connection', 'UserName', $sAdminName)
		Case $hPassword
			$sPassword = GUICtrlRead($hPassword)
			IniWrite($sIniFile, 'Connection', 'Password', $sPassword)
			For $i = 1 To UBound($aCC_ConnectSocket) - 1
				TCPCloseSocket($aCC_ConnectSocket[$i])
			Next
		Case $hUserList
			$msg = '[b]Zur Zeit angemeldete Benutzer:[/b]' & @CRLF
			$msg &= '[hr]+ ' & $sAdminName & ' (Server, IP-Adresse: ' & _GetIP() & ')' & @CRLF
			For $j = 1 To UBound($aCC_ConnectUser) - 1
				$msg &= '+ ' & $aCC_ConnectUser[$j] & ' (IP-Adresse: ' & $aCC_ConnectIP[$j] & ')' & @CRLF
			Next
			$msg &= '[hr]' & @CRLF
			_Chatbox_SetData($hChat, $msg)
		Case $hHelp
			_HelpMsg()
		Case $hEnter
			$tmp = GUICtrlRead($hUser)
			Select
				Case $tmp = '/HELP' Or $tmp = '/?' Or $tmp = '/HILFE'
					_HelpMsg()
				Case StringLeft($tmp, 2) = '/sf'

				Case Else
					_Chatbox_SetData($hChat, '[color=#dd0000][b]' & _Now() & ' Ich:[/b][/color] ' & $tmp, 0x000000, 3)
					If UBound($aCC_ConnectSocket) > 1 Then
						If StringLeft($tmp, 2) = '/w' Then
							$sWUser = StringRegExpReplace($tmp, '\/w (\w+) .+', '$1')
							$sMsg = '[color=#0000cc][b]' & _Now() & ' ' & $sAdminName & ' (psst):[/b][/color] ' & StringRegExpReplace($tmp, '\/w \w+ (.+)', '$1')
							For $j = 1 To UBound($aCC_ConnectUser) - 1
								If $aCC_ConnectUser[$j] = $sWUser Then
									TCPSend($aCC_ConnectSocket[$j], _StringEncryptXOR($sMsg, $sPassword))
									GUICtrlSetData($hUser, StringRegExpReplace($tmp, '(\/w \w+ ).+', '$1'))
									GUICtrlSetState($hUser, $GUI_FOCUS)
									GUICtrlSetState($hEnter, $GUI_DEFBUTTON)
									Return
								EndIf
							Next
							_Chatbox_SetData($hChat, 'FEHLER! Benutzer existiert nicht!', 0x000000, 2)
						Else
							For $i = 1 To UBound($aCC_ConnectSocket) - 1
								TCPSend($aCC_ConnectSocket[$i], _StringEncryptXOR('[color=#0000cc][b]' & _Now() & ' ' & $sAdminName & ':[/b][/color] ' & $tmp, $sPassword))
							Next
						EndIf
					EndIf
			EndSelect
			GUICtrlSetData($hUser, '')
			GUICtrlSetState($hUser, $GUI_FOCUS)
			GUICtrlSetState($hEnter, $GUI_DEFBUTTON)
	EndSwitch
	If GUICtrlRead($hPassword) <> $sPassword Then
		If BitAND(GUICtrlGetState($hAccept1), $GUI_DISABLE) Then GUICtrlSetState($hAccept1, $GUI_ENABLE)
	Else
		If BitAND(GUICtrlGetState($hAccept1), $GUI_ENABLE) Then GUICtrlSetState($hAccept1, $GUI_DISABLE)
	EndIf
	If GUICtrlRead($hAdminName) <> $sAdminName Then
		$sAdminName = StringRegExpReplace(GUICtrlRead($hAdminName), '\W', '')
		GUICtrlSetData($hAdminName, $sAdminName)
	EndIf
	If UBound($aCC_ConnectSocket) > 1 Then
		For $i = 1 To UBound($aCC_ConnectSocket) - 1
			$tmp = TCPRecv($aCC_ConnectSocket[$i], 1024, 1)
			If @error Then
				TCPCloseSocket($aCC_ConnectSocket[$i])
				_ArrayDelete($aCC_ConnectSocket, $i)
				$msg = '[size=2][b]' & _Now() & '[/b] >>> ' & $aCC_ConnectUser[$i] & ' (IP-Adresse: ' & $aCC_ConnectIP[$i] & ') hat sich abgemeldet![/size]'
				_Chatbox_SetData($hChat, $msg, 0x000000, 2)
				For $j = 1 To UBound($aCC_ConnectSocket) - 1
					TCPSend($aCC_ConnectSocket[$j], _StringEncryptXOR($msg, $sPassword))
				Next
				_ArrayDelete($aCC_ConnectUser, $i)
				_ArrayDelete($aCC_ConnectIP, $i)
				_GUICtrlStatusBar_SetText($hStatus, 'Angemeldete Benutzer: ' & UBound($aCC_ConnectSocket))
				ExitLoop
			EndIf
			$tmp = _StringEncryptXOR(BinaryToString($tmp), $sPassword)
			Select
				Case $tmp = '/UL'
					$msg = '[size=2][b]Zur Zeit angemeldete Benutzer:[/b]' & @CRLF
					$msg &= '[hr]+ "' & $sAdminName & '" (Server, IP-Adresse: ' & _GetIP() & ')' & @CRLF
					For $j = 1 To UBound($aCC_ConnectUser) - 1
						$msg &= '+ "' & $aCC_ConnectUser[$j] & '" (IP-Adresse: ' & $aCC_ConnectIP[$j] & ')' & @CRLF
					Next
					$msg &= '[hr][/size]' & @CRLF
					TCPSend($aCC_ConnectSocket[$i], _StringEncryptXOR($msg, $sPassword))
				Case StringLeft($tmp, 2) = '/w'
					$sWUser = StringRegExpReplace($tmp, '\/w (\w+) .+', '$1')
					$sMsg = '[color=#0000cc][b]' & _Now() & ' ' & $aCC_ConnectUser[$i] & ' (psst):[/b][/color] ' & StringRegExpReplace($tmp, '\/w \w+ (.+)', '$1')
					If $sWUser = $sAdminName Then
						_Chatbox_SetData($hChat, $sMsg, 0x000000, 3)
					Else
						For $j = 1 To UBound($aCC_ConnectUser) - 1
							If $aCC_ConnectUser[$j] = $sWUser Then
								TCPSend($aCC_ConnectSocket[$j], _StringEncryptXOR($sMsg, $sPassword))
								ContinueLoop 2
							EndIf
						Next
						TCPSend($aCC_ConnectSocket[$i], _StringEncryptXOR('FEHLER! Benutzer existiert nicht!', $sPassword))
					EndIf
				Case $tmp <> ''
					$tmp = '[color=#0000cc][b]' & _Now() & ' ' & $aCC_ConnectUser[$i] & ':[/b][/color] ' & $tmp
					_Chatbox_SetData($hChat, $tmp, 0x000000, 3)
					For $j = 1 To UBound($aCC_ConnectSocket) - 1
						If $j <> $i Then TCPSend($aCC_ConnectSocket[$j], _StringEncryptXOR($tmp, $sPassword))
					Next
			EndSelect
		Next
	EndIf
EndFunc

Func _HelpMsg()
	Local $msg
	$msg = '[b][size=4]Hilfe[/size][/b][hr]'
	$msg &= '[b][color=#000000][u]Befehlsliste:[/u][/color][/b]' & @CRLF
	$msg &= '[b][color=#0000ff]/ul[/color][/b] = Benutzerliste (wer ist online?)' & @CRLF
;~ 	$msg &= '[b][color=#0000ff]/sf Benutzer Dateiname[/color][/b] = Sende Datei an diesen Benutzer' & @CRLF
	$msg &= '[b][color=#0000ff]/w Benutzer Nachricht[/color][/b] = Nachricht nur an diesen Benutzer schicken' & @CRLF & @CRLF
	$msg &= '[b][color=#000000][u]BB-Codes (ohne die Leerzeichen eingeben):[/u][/color][/b]' & @CRLF
	$msg &= '[b][color=#0000ff][ b ][/color][/b]Fettschrift[b][color=#0000ff][ /b ][/color][/b] = [b]Fettschrift[/b]' & @CRLF
	$msg &= '[b][color=#0000ff][ i ][/color][/b]Kursivschrift[b][color=#0000ff][ /i ][/color][/b] = [i]Kursivschrift[/i]' & @CRLF
	$msg &= '[b][color=#0000ff][ u ][/color][/b]unterstrichen[b][color=#0000ff][ /u ][/color][/b] = [u]unterstrichen[/u]' & @CRLF
	$msg &= '[b][color=#0000ff][ color=#009900 ][/color][/b]grner Text[b][color=#0000ff][ /color ][/color][/b] = [color=#009900]grner Text[/color]' & @CRLF
	$msg &= '[b][color=#0000ff][ size=5 ][/color][/b]groer Text[b][color=#0000ff][ /size ][/color][/b] = [size=5]groer Text[/size]' & @CRLF
	$msg &= '[hr]' & @CRLF
	_Chatbox_SetData($hChat, $msg, 0x000000, 2)
EndFunc

Func _WM_SIZE($hWnd, $iMsg, $iwParam, $ilParam)
	_GUICtrlStatusBar_Resize($hStatus)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_SIZE

Func _WM_GETMINMAXINFO($hWnd, $msg, $wParam, $lParam)
	Local $minmaxinfo
	If $hWnd = $hGui Then
		$minmaxinfo = DllStructCreate('int;int;int;int;int;int;int;int;int;int', $lParam)
		DllStructSetData($minmaxinfo, 7, 612)
		DllStructSetData($minmaxinfo, 8, 612)
	EndIf
EndFunc   ;==>_WM_GETMINMAXINFO

Func _CC_Connect()
	Local $iConnect, $iTimer, $tmp, $aLogIn, $msg
	$iConnect = TCPAccept($iCC_ServerSocket)
	If $iConnect <> -1 Then
		$tmp = TCPRecv($iConnect, 1024)
		If _CC_UserExist($iConnect, $tmp) Then Return SetError(1, 0, 0)
		TCPSend($iConnect, 'PASSW')
		$iTimer = TimerInit()
		Do
			_CC_ReceiveMsg()
			$tmp = _StringEncryptXOR(BinaryToString(TCPRecv($iConnect, 1024, 1)), $sPassword)
		Until (@error <> 0) Or (Asc($tmp) <> 0) Or (TimerDiff($iTimer) > 30000)
		$aLogIn = StringSplit($tmp, '|', 2)
		If Not IsArray($aLogIn) Then
			TCPCloseSocket($iConnect)
		Else
			If _CC_UserExist($iConnect, $aLogIn[0]) Then Return SetError(1, 0, 0)
			If UBound($aLogIn) > 1 And $aLogIn[1] == $sPassword Then
				_ArrayAdd($aCC_ConnectUser, $aLogIn[0])
				_ArrayAdd($aCC_ConnectSocket, $iConnect)
				_ArrayAdd($aCC_ConnectIP, _SocketToIP($iConnect))
				_GUICtrlStatusBar_SetText($hStatus, 'Angemeldete Benutzer: ' & UBound($aCC_ConnectSocket))
				$msg = '[size=2][b]' &  _Now() & '[/b] >>> ' & $aLogIn[0] & ' (IP-Adresse: ' & $aCC_ConnectIP[UBound($aCC_ConnectIP) - 1] & ') hat sich angemeldet![/size]'
				_Chatbox_SetData($hChat, $msg, 0x000000, 2)
				For $j = 1 To UBound($aCC_ConnectSocket) - 2
					TCPSend($aCC_ConnectSocket[$j], _StringEncryptXOR($msg, $sPassword))
				Next
				TCPSend($iConnect, 'CONN1')
			Else
				TCPSend($iConnect, 'CONN0')
				TCPCloseSocket($iConnect)
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_CC_Connect

Func _CC_UserExist(ByRef $iConnect, $sUser)
	For $i = 0 To UBound($aCC_ConnectUser) - 1
		If $sUser = $aCC_ConnectUser[$i] Then
			TCPSend($iConnect, 'EXIST')
			TCPCloseSocket($iConnect)
			Return SetError(1, 0, 1)
		EndIf
	Next
	Return SetError(0, 0, 0)
EndFunc

Func _SocketToIP($SHOCKET)
	Local $sockaddr, $aRet
	$sockaddr = DllStructCreate('short;ushort;uint;char[8]')
	$aRet = DllCall('Ws2_32.dll', 'int', 'getpeername', 'int', $SHOCKET, _
			'ptr', DllStructGetPtr($sockaddr), 'int*', DllStructGetSize($sockaddr))
	If Not @error And $aRet[0] = 0 Then
		$aRet = DllCall('Ws2_32.dll', 'str', 'inet_ntoa', 'int', DllStructGetData($sockaddr, 3))
		If Not @error Then $aRet = $aRet[0]
	Else
		$aRet = 0
	EndIf
	$sockaddr = 0
	Return $aRet
EndFunc   ;==>_SocketToIP

Func _StringEncryptXOR($sText, $sPass)
	Local $sOut, $iTextChar, $iPos, $iPassChar, $iLen = StringLen($sPass)
	For $i = 1 To StringLen($sText)
		$iTextChar = Asc(StringMid($sText, $i, 1))
		$iPos = Mod($i, $iLen)
		$iPassChar = Asc(StringMid($sPass, $iPos, 1))
		$sOut &= Chr(BitXOR($iTextChar, $iPassChar))
	Next
	Return $sOut
EndFunc   ;==>_StringEncryptXOR

Func _Close($sErrMsg = '')
	If $sErrMsg <> '' Then MsgBox(262144 + 16, $sTitle, $sErrMsg, 0, $hGui)
	For $i = 1 To UBound($aCC_ConnectSocket) - 1
		TCPCloseSocket($aCC_ConnectSocket[$i])
	Next
	TCPCloseSocket($iCC_ServerSocket)
	TCPShutdown()
	Exit
EndFunc   ;==>_Close
